openapi: 3.0.3
info:
  contact:
    email: support@openlayer.com
    name: Openlayer
    url: 'https://openlayer.com/'
  description: API for interacting with the Openlayer server.
  title: Openlayer API
  version: '1.0'
  x-logo:
    url: 'https://logo.clearbit.com/openlayer.com'
servers:
  - url: 'https://api.openlayer.com/v1'
    description: Our prod backend
security:
  - bearerAuth: []
paths:
  '/workspaces/{workspaceId}':
    get:
      summary: Retrieve a workspace
      operationId: getWorkspaceById
      description: Retrieve a workspace.
      parameters:
        - $ref: '#/components/parameters/workspaceId'
      responses:
        '200':
          description: Response OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Workspace'
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            workspace = client.workspaces.retrieve("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
            print(workspace.name)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const workspace = await client.workspaces.retrieve('182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e');

            console.log(workspace.name);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\nworkspace, err := client.Workspaces.Get(context.TODO(), \"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\")\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", workspace.Name)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.WorkspaceRetrieveResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            WorkspaceRetrieveResponse workspace = client.workspaces().retrieve("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e");
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            workspace = openlayer.workspaces.retrieve("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")

            puts(workspace)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e \
              --header 'Authorization: Bearer <token>'
    put:
      summary: Update a workspace
      operationId: updateWorkspaceById
      description: Update a workspace.
      parameters:
        - $ref: '#/components/parameters/workspaceId'
      responses:
        '200':
          description: Response OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Workspace'
        default:
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  $ref: '#/components/schemas/Workspace/properties/name'
                slug:
                  $ref: '#/components/schemas/Workspace/properties/slug'
                inviteCode:
                  $ref: '#/components/schemas/Workspace/properties/inviteCode'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            workspace = client.workspaces.update(
                "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
                name="My Workspace",
                slug="my-workspace",
            )
            print(workspace.slug)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const workspace = await client.workspaces.update('182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e', {
              name: 'My Workspace',
              slug: 'my-workspace',
            });

            console.log(workspace.slug);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\nworkspace, err := client.Workspaces.Update(\n\tcontext.TODO(),\n\t\"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\",\n\topenlayer.WorkspaceUpdateParams{\n\t\tName: openlayer.F(\"Openlayer Staging\"),\n\t\tSlug: openlayer.F(\"openlayer-staging\"),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", workspace.Name)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.WorkspaceUpdateParams;
            import com.openlayer.api.models.workspaces.WorkspaceUpdateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            WorkspaceUpdateParams params = WorkspaceUpdateParams.builder()
                .workspaceId("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
                .name("Openlayer")
                .slug("openlayer")
                .build();
            WorkspaceUpdateResponse workspace = client.workspaces().update(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            workspace = openlayer.workspaces.update("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e", name: "Openlayer")

            puts(workspace)
        - lang: curl
          source: |
            curl --request PUT \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e \
              --header 'Authorization: Bearer <token>' \
              --data '{
                "name": "My Workspace",
                "slug": "my-workspace"
              }'
  '/workspaces/{workspaceId}/api-keys':
    get:
      summary: List API keys
      description: List your API keys in a workspace.
      operationId: listApiKeysInWorkspace
      parameters:
        - $ref: '#/components/parameters/workspaceId'
      responses:
        '200':
          description: Status OK.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ApiKey'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            api_keys = client.workspaces.api_keys.list("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
            for api_key in api_keys:
                print(api_key.id, api_key.name, api_key.status)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const apiKeys = await client.workspaces.apiKeys.list('182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e');

            console.log(apiKeys);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\napiKeys, err := client.Workspaces.APIKeys.List(context.TODO(), \"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\")\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", len(*apiKeys))\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyListResponse;
            import java.util.List;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            List<ApiKeyListResponse> apiKeys = client.workspaces().apiKeys().list("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e");
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            api_keys = openlayer.workspaces.api_keys.list("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")

            puts(api_keys)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e/api-keys \
              --header 'Authorization: Bearer <token>'
    post:
      summary: Create an API key
      description: Create a new API key.
      operationId: createApiKeyInWorkspace
      parameters:
        - $ref: '#/components/parameters/workspaceId'
      responses:
        '201':
          description: Status Created.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiKey'
        '400':
          description: '`expiresAt` is later than the calling API key''s expiry, or `null` while the calling key expires.'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  $ref: '#/components/schemas/ApiKey/properties/name'
                expiresAt:
                  $ref: '#/components/schemas/ApiKey/properties/expiresAt'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            api_key = client.workspaces.api_keys.create(
                "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
                name="CI pipeline",
                expires_at="2027-01-01T00:00:00Z",
            )
            print(api_key.secret)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const apiKey = await client.workspaces.apiKeys.create('182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e', {
              name: 'CI pipeline',
              expiresAt: '2027-01-01T00:00:00Z',
            });

            console.log(apiKey.secureKey);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\t\"time\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\napiKey, err := client.Workspaces.APIKeys.New(\n\tcontext.TODO(),\n\t\"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\",\n\topenlayer.WorkspaceAPIKeyNewParams{\n\t\tName:      openlayer.F(\"CI pipeline\"),\n\t\tExpiresAt: openlayer.F(time.Date(2027, 1, 1, 0, 0, 0, 0, time.UTC)),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", apiKey.Secret)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyCreateParams;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyCreateResponse;
            import java.time.OffsetDateTime;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            ApiKeyCreateParams params = ApiKeyCreateParams.builder()
                .workspaceId("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
                .name("CI pipeline key")
                .expiresAt(OffsetDateTime.parse("2027-01-01T00:00:00Z"))
                .build();
            ApiKeyCreateResponse apiKey = client.workspaces().apiKeys().create(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            api_key = openlayer.workspaces.api_keys.create(
              "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
              name: "Secret Key",
              expires_at: "2027-01-01T00:00:00Z"
            )

            puts(api_key.secure_key)
        - lang: curl
          source: |
            curl --request POST \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e/api-keys \
              --header 'Authorization: Bearer <token>' \
              --data '{
                "name": "My API Key",
                "expiresAt": "2027-01-01T00:00:00Z"
              }'
  '/workspaces/{workspaceId}/api-keys/{apiKeyId}':
    get:
      summary: Retrieve an API key
      description: Retrieve an API key.
      operationId: getApiKey
      parameters:
        - $ref: '#/components/parameters/workspaceId'
        - $ref: '#/components/parameters/apiKeyId'
      responses:
        '200':
          description: Status OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiKey'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            api_key = client.workspaces.api_keys.retrieve(
                "3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b",
                workspace_id="182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
            )
            print(api_key.status)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const apiKey = await client.workspaces.apiKeys.retrieve('3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b', {
              workspaceId: '182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e',
            });

            console.log(apiKey.name);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\napiKey, err := client.Workspaces.APIKeys.Get(\n\tcontext.TODO(),\n\t\"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\",\n\t\"3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b\",\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", apiKey.Status)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyRetrieveParams;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyRetrieveResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            ApiKeyRetrieveParams params = ApiKeyRetrieveParams.builder()
                .workspaceId("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
                .apiKeyId("3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b")
                .build();
            ApiKeyRetrieveResponse apiKey = client.workspaces().apiKeys().retrieve(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            api_key = openlayer.workspaces.api_keys.retrieve(
              "3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b",
              workspace_id: "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
            )

            puts(api_key)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e/api-keys/3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b \
              --header 'Authorization: Bearer <token>'
    put:
      summary: Update an API key
      description: Rename an API key.
      operationId: updateApiKey
      parameters:
        - $ref: '#/components/parameters/workspaceId'
        - $ref: '#/components/parameters/apiKeyId'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  $ref: '#/components/schemas/ApiKey/properties/name'
      responses:
        '200':
          description: Status OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiKey'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            api_key = client.workspaces.api_keys.update(
                "3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b",
                workspace_id="182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
                name="CI pipeline (prod)",
            )
            print(api_key.name)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const apiKey = await client.workspaces.apiKeys.update('3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b', {
              workspaceId: '182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e',
              name: 'CI pipeline (prod)',
            });

            console.log(apiKey.name);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\napiKey, err := client.Workspaces.APIKeys.Update(\n\tcontext.TODO(),\n\t\"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\",\n\t\"3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b\",\n\topenlayer.WorkspaceAPIKeyUpdateParams{\n\t\tName: openlayer.F(\"CI pipeline (prod)\"),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", apiKey.Name)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyUpdateParams;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyUpdateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            ApiKeyUpdateParams params = ApiKeyUpdateParams.builder()
                .workspaceId("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
                .apiKeyId("3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b")
                .name("CI pipeline key (prod)")
                .build();
            ApiKeyUpdateResponse apiKey = client.workspaces().apiKeys().update(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            api_key = openlayer.workspaces.api_keys.update(
              "3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b",
              workspace_id: "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
              name: "Production key"
            )

            puts(api_key)
        - lang: curl
          source: |
            curl --request PUT \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e/api-keys/3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b \
              --header 'Authorization: Bearer <token>' \
              --data '{"name": "Production ingest"}'
    delete:
      summary: Delete an API key
      description: Delete an API key.
      operationId: deleteApiKey
      parameters:
        - $ref: '#/components/parameters/workspaceId'
        - $ref: '#/components/parameters/apiKeyId'
      responses:
        '200':
          description: 'Key deleted. All of its secrets stop working immediately, including a previous secret still in its rotation grace period.'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            client.workspaces.api_keys.delete(
                "3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b",
                workspace_id="182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
            )
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            await client.workspaces.apiKeys.delete('3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b', {
              workspaceId: '182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e',
            });
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\nerr := client.Workspaces.APIKeys.Delete(\n\tcontext.TODO(),\n\t\"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\",\n\t\"3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b\",\n)\nif err != nil {\n\tpanic(err.Error())\n}\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyDeleteParams;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            ApiKeyDeleteParams params = ApiKeyDeleteParams.builder()
                .workspaceId("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
                .apiKeyId("3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b")
                .build();
            client.workspaces().apiKeys().delete(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            openlayer.workspaces.api_keys.delete(
              "3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b",
              workspace_id: "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
            )
        - lang: curl
          source: |
            curl --request DELETE \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e/api-keys/3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b \
              --header 'Authorization: Bearer <token>'
  '/workspaces/{workspaceId}/api-keys/{apiKeyId}/rotate':
    post:
      summary: Rotate an API key
      description: Replace an API key's secret.
      operationId: rotateApiKey
      parameters:
        - $ref: '#/components/parameters/workspaceId'
        - $ref: '#/components/parameters/apiKeyId'
      requestBody:
        required: false
        content:
          application/json:
            schema:
              type: object
              properties:
                gracePeriodHours:
                  type: integer
                  minimum: 0
                  maximum: 168
                  default: 0
                  example: 24
                  description: 'Hours the previous secret keeps authenticating. The default of 0 retires it immediately. It never outlives `expiresAt`. Only one previous secret is kept, so rotating again during a grace period retires the older one immediately.'
                expiresAt:
                  $ref: '#/components/schemas/ApiKey/properties/expiresAt'
      responses:
        '200':
          description: 'The rotated key. It keeps its id and name, and the new secret is in `secret`.'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiKey'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            api_key = client.workspaces.api_keys.rotate(
                "3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b",
                workspace_id="182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
                grace_period_hours=24,
            )
            print(api_key.secret)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const apiKey = await client.workspaces.apiKeys.rotate('3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b', {
              workspaceId: '182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e',
              gracePeriodHours: 24,
            });

            console.log(apiKey.secureKey);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\napiKey, err := client.Workspaces.APIKeys.Rotate(\n\tcontext.TODO(),\n\t\"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\",\n\t\"3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b\",\n\topenlayer.WorkspaceAPIKeyRotateParams{\n\t\tGracePeriodHours: openlayer.Int(24),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", apiKey.Secret)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyRotateParams;
            import com.openlayer.api.models.workspaces.apikeys.ApiKeyRotateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            ApiKeyRotateParams params = ApiKeyRotateParams.builder()
                .workspaceId("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
                .apiKeyId("3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b")
                .gracePeriodHours(24L)
                .build();
            ApiKeyRotateResponse rotated = client.workspaces().apiKeys().rotate(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            api_key = openlayer.workspaces.api_keys.rotate(
              "3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b",
              workspace_id: "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
              grace_period_hours: 24
            )

            puts(api_key.secure_key)
        - lang: curl
          source: |
            curl --request POST \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e/api-keys/3f2b9c1e-8a4d-4e6f-9b7a-1c2d3e4f5a6b/rotate \
              --header 'Authorization: Bearer <token>' \
              --data '{"gracePeriodHours": 24, "expiresAt": "2027-06-01T00:00:00Z"}'
  '/workspaces/{workspaceId}/invites':
    get:
      summary: List invites
      operationId: getInvitesByWorkspace
      description: List the invites in a workspace.
      parameters:
        - $ref: '#/components/parameters/workspaceId'
        - $ref: '#/components/parameters/page'
        - $ref: '#/components/parameters/perPage'
      responses:
        '200':
          description: Status OK.
          headers:
            x-next:
              description: A link to the next page of responses
              schema:
                type: string
          content:
            application/json:
              schema:
                type: object
                required:
                  - items
                properties:
                  items:
                    type: array
                    items:
                      $ref: '#/components/schemas/Invite'
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            invites = client.workspaces.invites.list("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
            print(invites.items)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const invites = await client.workspaces.invites.list('182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e', { page: 1, perPage: 25 });

            console.log(invites.items);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\ninvites, err := client.Workspaces.Invites.List(\n\tcontext.TODO(),\n\t\"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\",\n\topenlayer.WorkspaceInviteListParams{},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", invites.Items)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.invites.InviteListParams;
            import com.openlayer.api.models.workspaces.invites.InviteListResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            InviteListParams params = InviteListParams.builder()
                .workspaceId("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
                .perPage(25L)
                .build();
            InviteListResponse invites = client.workspaces().invites().list(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            invites = openlayer.workspaces.invites.list("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")

            puts(invites)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e/invites \
              --header 'Authorization: Bearer <token>'
    post:
      summary: Invite users to a workspace
      operationId: inviteUsersToWorkspace
      description: Invite users to a workspace.
      parameters:
        - $ref: '#/components/parameters/workspaceId'
      responses:
        '201':
          description: Status OK.
          content:
            application/json:
              schema:
                type: object
                required:
                  - items
                properties:
                  items:
                    type: array
                    items:
                      $ref: '#/components/schemas/Invite'
        default:
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                emails:
                  type: array
                  items:
                    $ref: '#/components/schemas/Member/properties/email'
                role:
                  $ref: '#/components/schemas/Member/properties/membership/properties/role'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            invites = client.workspaces.invites.create(
                "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
                emails=["jane@example.com", "john@example.com"],
                role="MEMBER",
            )
            print(invites.items)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const invites = await client.workspaces.invites.create('182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e', {
              emails: ['jane@example.com', 'john@example.com'],
              role: 'MEMBER',
            });

            console.log(invites.items);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\ninvites, err := client.Workspaces.Invites.New(\n\tcontext.TODO(),\n\t\"182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e\",\n\topenlayer.WorkspaceInviteNewParams{\n\t\tEmails: openlayer.F([]string{\"jane@example.com\", \"john@example.com\"}),\n\t\tRole:   openlayer.F(openlayer.WorkspaceInviteNewParamsRoleMember),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", invites.Items)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.workspaces.invites.InviteCreateParams;
            import com.openlayer.api.models.workspaces.invites.InviteCreateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            InviteCreateParams params = InviteCreateParams.builder()
                .workspaceId("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e")
                .addEmail("teammate@example.com")
                .role(InviteCreateParams.Role.MEMBER)
                .build();
            InviteCreateResponse invite = client.workspaces().invites().create(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            invites = openlayer.workspaces.invites.create(
              "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
              emails: ["user@email.com"],
              role: :MEMBER
            )

            puts(invites)
        - lang: curl
          source: |
            curl --request POST \
              --url https://api.openlayer.com/v1/workspaces/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e/invites \
              --header 'Authorization: Bearer <token>' \
              --data '{
                "emails": ["john@doe.com", "jane@doe.com"],
                "role": "ADMIN"
              }'
  /projects:
    get:
      summary: List projects
      operationId: listProjects
      description: List your workspace's projects.
      parameters:
        - $ref: '#/components/parameters/page'
        - $ref: '#/components/parameters/perPage'
        - $ref: '#/components/parameters/projectName'
        - $ref: '#/components/parameters/taskType'
      responses:
        '200':
          description: Status OK.
          headers:
            x-next:
              description: A link to the next page of responses
              schema:
                type: string
          content:
            application/json:
              schema:
                type: object
                required:
                  - items
                properties:
                  items:
                    type: array
                    items:
                      $ref: '#/components/schemas/Project'
        '500':
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            projects = client.projects.list(task_type="llm-base")
            for project in projects.items:
                print(project.id, project.name)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const projects = await client.projects.list({ taskType: 'llm-base' });

            console.log(projects.items);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\nprojects, err := client.Projects.List(context.TODO(), openlayer.ProjectListParams{\n\tTaskType: openlayer.F(openlayer.ProjectListParamsTaskTypeLlmBase),\n})\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", projects.Items)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.projects.ProjectListParams;
            import com.openlayer.api.models.projects.ProjectListResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            ProjectListParams params = ProjectListParams.builder()
                .taskType(ProjectListParams.TaskType.LLM_BASE)
                .build();
            ProjectListResponse projects = client.projects().list(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            projects = openlayer.projects.list(task_type: :"llm-base")

            puts(projects)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/projects \
              --header 'Authorization: Bearer <token>'
    post:
      tags:
        - Projects
      summary: Create project
      operationId: createProject
      description: Create a project in your workspace.
      responses:
        '201':
          description: Status OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Project'
        default:
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Project'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            project = client.projects.create(
                name="Customer support chatbot",
                task_type="llm-base",
                description="Answers customer questions about billing.",
            )
            print(project.id)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const project = await client.projects.create({
              name: 'My Project',
              taskType: 'llm-base',
              description: 'My project description.',
            });

            console.log(project.id);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\nproject, err := client.Projects.New(context.TODO(), openlayer.ProjectNewParams{\n\tName:     openlayer.F(\"My Project\"),\n\tTaskType: openlayer.F(openlayer.ProjectNewParamsTaskTypeLlmBase),\n})\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", project.ID)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.core.JsonMissing;
            import com.openlayer.api.models.projects.ProjectCreateParams;
            import com.openlayer.api.models.projects.ProjectCreateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            ProjectCreateParams params = ProjectCreateParams.builder()
                .name("My Project")
                .taskType(ProjectCreateParams.TaskType.LLM_BASE)
                .description("My project description.")
                // Server-assigned fields the Java SDK marks as required: leave them out of the request.
                .id(JsonMissing.of())
                .workspaceId(JsonMissing.of())
                .creatorId(JsonMissing.of())
                .dateCreated(JsonMissing.of())
                .dateUpdated(JsonMissing.of())
                .source(JsonMissing.of())
                .versionCount(JsonMissing.of())
                .inferencePipelineCount(JsonMissing.of())
                .goalCount(JsonMissing.of())
                .developmentGoalCount(JsonMissing.of())
                .monitoringGoalCount(JsonMissing.of())
                .links(JsonMissing.of())
                .build();
            ProjectCreateResponse project = client.projects().create(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            project = openlayer.projects.create(
              name: "My Project",
              task_type: :"llm-base",
              description: "My project description."
            )

            puts(project)
        - lang: curl
          source: |
            curl --request POST \
              --url https://api.openlayer.com/v1/projects \
              --header 'Authorization: Bearer <token>' \
              --header 'Content-Type: application/json' \
              --data '{
                "name": "My Project",
                "description": "My project description.",
                "taskType": "llm-base"
              }'
  '/projects/{projectId}':
    patch:
      tags:
        - Projects
      summary: Update project
      operationId: updateProject
      description: Update a project's metadata.
      security:
        - apiKey: []
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/projectId'
      responses:
        '200':
          description: Response OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Project'
        default:
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              additionalProperties: false
              properties:
                name:
                  $ref: '#/components/schemas/Project/properties/name'
                description:
                  $ref: '#/components/schemas/Project/properties/description'
                purpose:
                  $ref: '#/components/schemas/Project/properties/purpose'
                modelTypes:
                  $ref: '#/components/schemas/Project/properties/modelTypes'
                modelDeveloper:
                  $ref: '#/components/schemas/Project/properties/modelDeveloper'
                dataRetentionDays:
                  $ref: '#/components/schemas/Project/properties/dataRetentionDays'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            project = client.projects.update(
                "3fa85f64-5717-4562-b3fc-2c963f66afa6",
                name="Customer support chatbot",
                description="Answers customer questions about billing and refunds.",
            )
            print(project.name)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const project = await client.projects.update('3fa85f64-5717-4562-b3fc-2c963f66afa6', {
              name: 'My Renamed Project',
              description: 'An updated project description.',
            });

            console.log(project.name);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\nproject, err := client.Projects.Update(\n\tcontext.TODO(),\n\t\"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n\topenlayer.ProjectUpdateParams{\n\t\tName:        openlayer.F(\"My Renamed Project\"),\n\t\tDescription: openlayer.F(\"An updated project description.\"),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", project.Name)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.projects.ProjectUpdateParams;
            import com.openlayer.api.models.projects.ProjectUpdateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            ProjectUpdateParams params = ProjectUpdateParams.builder()
                .projectId("3fa85f64-5717-4562-b3fc-2c963f66afa6")
                .description("Customer support assistant.")
                .dataRetentionDays(90L)
                .build();
            ProjectUpdateResponse project = client.projects().update(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            project = openlayer.projects.update(
              "3fa85f64-5717-4562-b3fc-2c963f66afa6",
              description: "My project description."
            )

            puts(project)
        - lang: curl
          source: |
            curl --request PATCH \
              --url https://api.openlayer.com/v1/projects/3fa85f64-5717-4562-b3fc-2c963f66afa6 \
              --header 'Authorization: Bearer <token>' \
              --header 'Content-Type: application/json' \
              --data '{
                "name": "My Renamed Project",
                "description": "An updated project description."
              }'
    delete:
      tags:
        - Projects
      summary: Delete project
      operationId: deleteProject
      description: Delete a project by its ID.
      security:
        - apiKey: []
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/projectId'
      responses:
        '200':
          description: Response OK.
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            client.projects.delete("3fa85f64-5717-4562-b3fc-2c963f66afa6")
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            await client.projects.delete('3fa85f64-5717-4562-b3fc-2c963f66afa6');
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\nerr := client.Projects.Delete(context.TODO(), \"3fa85f64-5717-4562-b3fc-2c963f66afa6\")\nif err != nil {\n\tpanic(err.Error())\n}\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            client.projects().delete("3fa85f64-5717-4562-b3fc-2c963f66afa6");
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            openlayer.projects.delete("3fa85f64-5717-4562-b3fc-2c963f66afa6")
        - lang: curl
          source: |
            curl --request DELETE \
              --url https://api.openlayer.com/v1/projects/3fa85f64-5717-4562-b3fc-2c963f66afa6 \
              --header 'Authorization: Bearer <token>'
  '/projects/{projectId}/versions':
    get:
      tags:
        - Development
      summary: List project commits
      operationId: listProjectVersionsByProject
      description: List the commits (project versions) in a project.
      parameters:
        - $ref: '#/components/parameters/projectId'
        - $ref: '#/components/parameters/page'
        - $ref: '#/components/parameters/perPage'
      responses:
        '200':
          description: Status OK.
          headers:
            x-next:
              description: A link to the next page of responses
              schema:
                type: string
          content:
            application/json:
              schema:
                type: object
                required:
                  - items
                properties:
                  items:
                    type: array
                    items:
                      $ref: '#/components/schemas/ProjectVersion'
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            commits = client.projects.commits.list("3fa85f64-5717-4562-b3fc-2c963f66afa6")
            for commit in commits.items:
                print(commit.id, commit.commit.message)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const commits = await client.projects.commits.list('3fa85f64-5717-4562-b3fc-2c963f66afa6');

            console.log(commits.items);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\ncommits, err := client.Projects.Commits.List(\n\tcontext.TODO(),\n\t\"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n\topenlayer.ProjectCommitListParams{},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", commits.Items)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.projects.commits.CommitListResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            CommitListResponse commits = client.projects().commits().list("3fa85f64-5717-4562-b3fc-2c963f66afa6");
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            commits = openlayer.projects.commits.list("3fa85f64-5717-4562-b3fc-2c963f66afa6")

            puts(commits)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/projects/{projectId}/versions \
              --header 'Authorization: Bearer <token>'
    post:
      tags:
        - Development
      summary: Create project commit
      operationId: createProjectVersion
      description: Create a new commit (project version) in a project.
      parameters:
        - $ref: '#/components/parameters/projectId'
      responses:
        '201':
          description: Status OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectVersion'
        default:
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ProjectVersion'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            commit = client.projects.commits.create(
                "3fa85f64-5717-4562-b3fc-2c963f66afa6",
                commit={"message": "Updated the prompt"},
                storage_uri="s3://openlayer-bucket/commits/bundle.tar.gz",
            )
            print(commit.id, commit.status)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const commit = await client.projects.commits.create('3fa85f64-5717-4562-b3fc-2c963f66afa6', {
              commit: { message: 'Updated the prompt.' },
              storageUri: 's3://openlayer-bucket/commits/my-commit.tar.gz',
            });

            console.log(commit.id);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\ncommit, err := client.Projects.Commits.New(\n\tcontext.TODO(),\n\t\"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n\topenlayer.ProjectCommitNewParams{\n\t\tCommit: openlayer.F(openlayer.ProjectCommitNewParamsCommit{\n\t\t\tMessage: openlayer.F(\"Updated the prompt.\"),\n\t\t}),\n\t\tStorageUri: openlayer.F(\"s3://openlayer-bucket/uploads/my-project/commit.tar.gz\"),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", commit.ID)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.core.JsonMissing;
            import com.openlayer.api.models.projects.commits.CommitCreateParams;
            import com.openlayer.api.models.projects.commits.CommitCreateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            CommitCreateParams params = CommitCreateParams.builder()
                .pathProjectId("3fa85f64-5717-4562-b3fc-2c963f66afa6")
                .storageUri("s3://openlayer-uploads/model_package.tar.gz")
                .commit(CommitCreateParams.Commit.builder()
                    .message("Updated the prompt.")
                    // Server-assigned fields the Java SDK marks as required: leave them out of the request.
                    .id(JsonMissing.of())
                    .authorId(JsonMissing.of())
                    .fileSize(JsonMissing.of())
                    .mlModelId(JsonMissing.of())
                    .storageUri(JsonMissing.of())
                    .trainingDatasetId(JsonMissing.of())
                    .validationDatasetId(JsonMissing.of())
                    .build())
                .id(JsonMissing.of())
                .bodyProjectId(JsonMissing.of())
                .dateCreated(JsonMissing.of())
                .dateArchived(JsonMissing.of())
                .status(JsonMissing.of())
                .statusMessage(JsonMissing.of())
                .mlModelId(JsonMissing.of())
                .trainingDatasetId(JsonMissing.of())
                .validationDatasetId(JsonMissing.of())
                .passingGoalCount(JsonMissing.of())
                .failingGoalCount(JsonMissing.of())
                .totalGoalCount(JsonMissing.of())
                .build();
            CommitCreateResponse commit = client.projects().commits().create(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            commit = openlayer.projects.commits.create(
              "3fa85f64-5717-4562-b3fc-2c963f66afa6",
              commit: {message: "Updated the prompt."},
              storage_uri: "s3://my-bucket/commits/bundle.tar.gz"
            )

            puts(commit)
        - lang: curl
          source: |
            curl --request POST \
              --url https://api.openlayer.com/v1/projects/{projectId}/versions \
              --header 'Authorization: Bearer <token>' \
              --data '{"message": "Updated the prompt", "storageUri": "s3://..."}'
  '/projects/{projectId}/inference-pipelines':
    get:
      tags:
        - Monitoring
      summary: List inference pipelines
      operationId: listInferencePipelinesByProject
      description: List the inference pipelines in a project.
      parameters:
        - $ref: '#/components/parameters/projectId'
        - $ref: '#/components/parameters/page'
        - $ref: '#/components/parameters/perPage'
        - name: name
          in: query
          description: Filter list of items by name.
          required: false
          schema:
            type: string
      responses:
        '200':
          description: Status OK.
          headers:
            x-next:
              description: A link to the next page of responses
              schema:
                type: string
          content:
            application/json:
              schema:
                type: object
                required:
                  - items
                properties:
                  items:
                    type: array
                    items:
                      $ref: '#/components/schemas/InferencePipeline'
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            inference_pipelines = client.projects.inference_pipelines.list("3fa85f64-5717-4562-b3fc-2c963f66afa6")
            for inference_pipeline in inference_pipelines.items:
                print(inference_pipeline.id, inference_pipeline.name)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const inferencePipelines = await client.projects.inferencePipelines.list('3fa85f64-5717-4562-b3fc-2c963f66afa6');

            console.log(inferencePipelines.items);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\npipelines, err := client.Projects.InferencePipelines.List(\n\tcontext.TODO(),\n\t\"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n\topenlayer.ProjectInferencePipelineListParams{\n\t\tName: openlayer.F(\"production\"),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", pipelines.Items)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.projects.inferencepipelines.InferencePipelineListParams;
            import com.openlayer.api.models.projects.inferencepipelines.InferencePipelineListResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            InferencePipelineListParams params = InferencePipelineListParams.builder()
                .projectId("3fa85f64-5717-4562-b3fc-2c963f66afa6")
                .name("production")
                .build();
            InferencePipelineListResponse inferencePipelines = client.projects().inferencePipelines().list(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            inference_pipelines = openlayer.projects.inference_pipelines.list("3fa85f64-5717-4562-b3fc-2c963f66afa6")

            puts(inference_pipelines)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/projects/{projectId}/inference-pipelines \
              --header 'Authorization: Bearer <token>'
    post:
      tags:
        - Monitoring
      summary: Create inference pipeline
      description: Create an inference pipeline in a project.
      operationId: createInferencePipelineInProject
      parameters:
        - $ref: '#/components/parameters/projectId'
      responses:
        '200':
          description: Status OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InferencePipeline'
        default:
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/InferencePipeline'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            inference_pipeline = client.projects.inference_pipelines.create(
                "3fa85f64-5717-4562-b3fc-2c963f66afa6",
                name="production",
                description="Production traffic from the support chatbot.",
            )
            print(inference_pipeline.id)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const inferencePipeline = await client.projects.inferencePipelines.create('3fa85f64-5717-4562-b3fc-2c963f66afa6', {
              name: 'production',
              description: 'Production traffic for the support chatbot.',
            });

            console.log(inferencePipeline.id);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\npipeline, err := client.Projects.InferencePipelines.New(\n\tcontext.TODO(),\n\t\"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n\topenlayer.ProjectInferencePipelineNewParams{\n\t\tName:        openlayer.F(\"production\"),\n\t\tDescription: openlayer.F(\"My production inference pipeline.\"),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", pipeline.ID)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.core.JsonMissing;
            import com.openlayer.api.models.projects.inferencepipelines.InferencePipelineCreateParams;
            import com.openlayer.api.models.projects.inferencepipelines.InferencePipelineCreateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            InferencePipelineCreateParams params = InferencePipelineCreateParams.builder()
                .pathProjectId("3fa85f64-5717-4562-b3fc-2c963f66afa6")
                .name("production")
                .description("This pipeline is used for production.")
                // Server-assigned fields the Java SDK marks as required: leave them out of the request.
                .id(JsonMissing.of())
                .bodyProjectId(JsonMissing.of())
                .dateCreated(JsonMissing.of())
                .dateUpdated(JsonMissing.of())
                .dateLastSampleReceived(JsonMissing.of())
                .dateLastEvaluated(JsonMissing.of())
                .dateOfNextEvaluation(JsonMissing.of())
                .passingGoalCount(JsonMissing.of())
                .failingGoalCount(JsonMissing.of())
                .totalGoalCount(JsonMissing.of())
                .status(JsonMissing.of())
                .statusMessage(JsonMissing.of())
                .links(JsonMissing.of())
                .build();
            InferencePipelineCreateResponse inferencePipeline = client.projects().inferencePipelines().create(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            inference_pipeline = openlayer.projects.inference_pipelines.create(
              "3fa85f64-5717-4562-b3fc-2c963f66afa6",
              name: "production",
              description: "This pipeline is used for production."
            )

            puts(inference_pipeline)
        - lang: curl
          source: |
            curl --request POST \
              --url https://api.openlayer.com/v1/projects/{projectId}/inference-pipelines \
              --header 'Authorization: Bearer <token>' \
              --header 'Content-Type: application/json' \
              --data '{
              "name": "production",
              "description": "My production inference pipeline."
            }'
  '/versions/{projectVersionId}':
    get:
      description: Retrieve a project commit.
      operationId: getVersionById
      summary: Retrieve a project commit
      security:
        - apiKey: []
        - bearerAuth: []
      parameters:
        - $ref: '#/components/parameters/projectVersionId'
      responses:
        '200':
          description: Response OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectVersion'
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            commit = client.commits.retrieve("b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20")
            print(commit.status, commit.passing_goal_count, commit.total_goal_count)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const commit = await client.commits.retrieve('b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20');

            console.log(commit.status);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\ncommit, err := client.Commits.Get(context.TODO(), \"b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20\")\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", commit.Status)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.commits.CommitRetrieveResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            CommitRetrieveResponse commit = client.commits().retrieve("b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20");
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            commit = openlayer.commits.retrieve("b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20")

            puts(commit)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/versions/182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e \
              --header 'Authorization: Bearer <token>'
  '/projects/{projectId}/tests':
    post:
      tags:
        - Projects
      description: Create a test in a project.
      summary: Create a test
      operationId: createTest
      parameters:
        - $ref: '#/components/parameters/projectId'
      responses:
        '201':
          description: Status OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TestBase'
        default:
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TestBase'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            test = client.projects.tests.create(
                "3fa85f64-5717-4562-b3fc-2c963f66afa6",
                name="No duplicate rows",
                description="Fails if the data contains duplicate rows.",
                type="integrity",
                subtype="duplicateRowCount",
                thresholds=[
                    {
                        "insight_name": "duplicateRowCount",
                        "measurement": "duplicateRowCount",
                        "operator": "<=",
                        "value": 0,
                    }
                ],
                uses_production_data=True,
                evaluation_window=3600,
            )
            print(test.id)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const test = await client.projects.tests.create('3fa85f64-5717-4562-b3fc-2c963f66afa6', {
              name: 'No duplicate rows',
              description: 'This test checks for duplicate rows in the dataset.',
              type: 'integrity',
              subtype: 'duplicateRowCount',
              thresholds: [
                {
                  insightName: 'duplicateRowCount',
                  measurement: 'duplicateRowCount',
                  operator: '<=',
                  value: 0,
                },
              ],
            });

            console.log(test.id);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n\t\"github.com/openlayer-ai/openlayer-go/shared\"\n)\n\nclient := openlayer.NewClient()\ntest, err := client.Projects.Tests.New(\n\tcontext.TODO(),\n\t\"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n\topenlayer.ProjectTestNewParams{\n\t\tName:        openlayer.F(\"No duplicate rows\"),\n\t\tDescription: openlayer.F[any](\"This test checks for duplicate rows in the dataset.\"),\n\t\tType:        openlayer.F(openlayer.ProjectTestNewParamsTypeIntegrity),\n\t\tSubtype:     openlayer.F(openlayer.ProjectTestNewParamsSubtypeDuplicateRowCount),\n\t\tThresholds: openlayer.F([]openlayer.ProjectTestNewParamsThreshold{{\n\t\t\tInsightName: openlayer.F(openlayer.ProjectTestNewParamsThresholdsInsightNameDuplicateRowCount),\n\t\t\tMeasurement: openlayer.F(\"duplicateRowCount\"),\n\t\t\tOperator:    openlayer.F(openlayer.ProjectTestNewParamsThresholdsOperatorLessOrEquals),\n\t\t\tValue:       openlayer.F[openlayer.ProjectTestNewParamsThresholdsValueUnion](shared.UnionFloat(0)),\n\t\t}}),\n\t\tUsesProductionData: openlayer.F(true),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", test.ID)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.core.JsonMissing;
            import com.openlayer.api.core.JsonValue;
            import com.openlayer.api.models.projects.tests.TestCreateParams;
            import com.openlayer.api.models.projects.tests.TestCreateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            TestCreateParams params = TestCreateParams.builder()
                .projectId("3fa85f64-5717-4562-b3fc-2c963f66afa6")
                .name("No duplicate rows")
                .description(JsonValue.from("This test checks for duplicate rows in the dataset."))
                .type(TestCreateParams.Type.INTEGRITY)
                .subtype(TestCreateParams.Subtype.DUPLICATE_ROW_COUNT)
                .addThreshold(TestCreateParams.Threshold.builder()
                    .insightName(TestCreateParams.Threshold.InsightName.DUPLICATE_ROW_COUNT)
                    .measurement("duplicateRowCount")
                    .operator(TestCreateParams.Threshold.Operator.LESS_OR_EQUALS)
                    .value(0.0)
                    .build())
                // Server-assigned fields the Java SDK marks as required: leave them out of the request.
                .id(JsonMissing.of())
                .number(JsonMissing.of())
                .creatorId(JsonMissing.of())
                .originProjectVersionId(JsonMissing.of())
                .dateCreated(JsonMissing.of())
                .dateUpdated(JsonMissing.of())
                .dateArchived(JsonMissing.of())
                .suggested(JsonMissing.of())
                .commentCount(JsonMissing.of())
                .build();
            TestCreateResponse test = client.projects().tests().create(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            test = openlayer.projects.tests.create(
              "3fa85f64-5717-4562-b3fc-2c963f66afa6",
              name: "No duplicate rows",
              description: "This test checks for duplicate rows in the dataset.",
              type: :integrity,
              subtype: :duplicateRowCount,
              thresholds: [
                {
                  insight_name: :duplicateRowCount,
                  measurement: "duplicateRowCount",
                  operator: :<=,
                  value: 0.0
                }
              ]
            )

            puts(test)
        - lang: curl
          source: |
            curl --request POST \
              --url https://api.openlayer.com/v1/projects/{projectId}/tests \
              --header 'Authorization: Bearer <token>' \
              --header 'Content-Type: application/json' \
              --data '{
                "name": "No duplicate rows",
                "description": "This test checks for duplicate rows in the dataset.",
                "type": "integrity",
                "subtype": "duplicateRowCount",
                "thresholds": [
                  {
                    "insightName": "duplicateRowCount",
                    "measurement": "duplicateRowCount",
                    "operator": "<=",
                    "value": 0
                  }
                ],
                "usesProductionData": true,
                "evaluationWindow": 3600,
                "delayWindow": 0,
                "usesTrainingDataset": false,
                "usesValidationDataset": false,
              }'
    get:
      tags:
        - Projects
      description: List the tests in a project.
      summary: List tests
      operationId: listTests
      parameters:
        - $ref: '#/components/parameters/projectId'
        - $ref: '#/components/parameters/page'
        - $ref: '#/components/parameters/perPage'
        - $ref: '#/components/parameters/goalType'
        - name: suggested
          in: query
          description: Filter for suggested tests.
          schema:
            type: boolean
            default: false
        - $ref: '#/components/parameters/includeArchived'
        - name: originVersionId
          in: query
          description: Retrive tests created by a specific project version.
          schema:
            type: string
            format: uuid
            readOnly: false
            description: The project version (commit) id.
            example: 3fa85f64-5717-4562-b3fc-2c963f66afa6
            nullable: true
        - name: usesProductionData
          in: query
          description: Retrive tests with usesProductionData (monitoring).
          schema:
            type: boolean
            nullable: true
      responses:
        '200':
          description: Status OK.
          headers:
            x-next:
              description: A link to the next page of responses
              schema:
                type: string
          content:
            application/json:
              schema:
                type: object
                required:
                  - items
                properties:
                  items:
                    type: array
                    items:
                      $ref: '#/components/schemas/TestBase'
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            tests = client.projects.tests.list(
                "3fa85f64-5717-4562-b3fc-2c963f66afa6",
                type="integrity",
            )
            for test in tests.items:
                print(test.id, test.name)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const tests = await client.projects.tests.list('3fa85f64-5717-4562-b3fc-2c963f66afa6', { type: 'integrity' });

            console.log(tests.items);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\ntests, err := client.Projects.Tests.List(\n\tcontext.TODO(),\n\t\"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n\topenlayer.ProjectTestListParams{\n\t\tType: openlayer.F(openlayer.ProjectTestListParamsTypeIntegrity),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", tests.Items)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.projects.tests.TestListParams;
            import com.openlayer.api.models.projects.tests.TestListResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            TestListParams params = TestListParams.builder()
                .projectId("3fa85f64-5717-4562-b3fc-2c963f66afa6")
                .usesProductionData(true)
                .build();
            TestListResponse tests = client.projects().tests().list(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            tests = openlayer.projects.tests.list("3fa85f64-5717-4562-b3fc-2c963f66afa6", type: :integrity)

            puts(tests)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/projects/{projectId}/tests \
              --header 'Authorization: Bearer <token>'
    put:
      tags:
        - Projects
      summary: Update tests
      description: Update tests in a project.
      parameters:
        - $ref: '#/components/parameters/projectId'
      responses:
        '202':
          description: Response OK. Task queued.
          content:
            application/json:
              schema:
                type: object
                properties:
                  taskResultUrl:
                    type: string
                  taskResultId:
                    type: string
        default:
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              required:
                - payloads
              properties:
                payloads:
                  type: array
                  maxLength: 400
                  items:
                    type: object
                    required:
                      - id
                    properties:
                      id:
                        type: string
                        format: uuid
                      name:
                        $ref: '#/components/schemas/TestBase/properties/name'
                      description:
                        $ref: '#/components/schemas/TestBase/properties/description'
                      archived:
                        $ref: '#/components/schemas/TestBase/properties/archived'
                      thresholds:
                        $ref: '#/components/schemas/TestBase/properties/thresholds'
                      suggested:
                        type: boolean
                        enum:
                          - false
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            response = client.projects.tests.update(
                "3fa85f64-5717-4562-b3fc-2c963f66afa6",
                payloads=[
                    {
                        "id": "9a8b7c6d-5e4f-4a3b-2c1d-0e9f8a7b6c5d",
                        "name": "No duplicate rows",
                        "thresholds": [
                            {
                                "insight_name": "duplicateRowCount",
                                "measurement": "duplicateRowCount",
                                "operator": "<=",
                                "value": 5,
                            }
                        ],
                    }
                ],
            )
            print(response.task_result_id)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const response = await client.projects.tests.update('3fa85f64-5717-4562-b3fc-2c963f66afa6', {
              payloads: [
                {
                  id: '9a8b7c6d-5e4f-4a3b-2c1d-0e9f8a7b6c5d',
                  name: 'No duplicate rows',
                  archived: false,
                },
              ],
            });

            console.log(response);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\ntask, err := client.Projects.Tests.Update(\n\tcontext.TODO(),\n\t\"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n\topenlayer.ProjectTestUpdateParams{\n\t\tPayloads: openlayer.F([]openlayer.ProjectTestUpdateParamsPayload{{\n\t\t\tID:       openlayer.F(\"9a8b7c6d-5e4f-4a3b-2c1d-0e9f8a7b6c5d\"),\n\t\t\tName:     openlayer.F(\"No duplicate rows (strict)\"),\n\t\t\tArchived: openlayer.F(false),\n\t\t}}),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", task.TaskResultID)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.projects.tests.TestUpdateParams;
            import com.openlayer.api.models.projects.tests.TestUpdateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            TestUpdateParams params = TestUpdateParams.builder()
                .projectId("3fa85f64-5717-4562-b3fc-2c963f66afa6")
                .addPayload(TestUpdateParams.Payload.builder()
                    .id("9a8b7c6d-5e4f-4a3b-2c1d-0e9f8a7b6c5d")
                    .name("No duplicate rows")
                    .archived(false)
                    .build())
                .build();
            TestUpdateResponse response = client.projects().tests().update(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            response = openlayer.projects.tests.update(
              "3fa85f64-5717-4562-b3fc-2c963f66afa6",
              payloads: [{id: "9a8b7c6d-5e4f-4a3b-2c1d-0e9f8a7b6c5d", name: "No duplicate rows", archived: false}]
            )

            puts(response)
        - lang: curl
          source: |
            curl --request PUT \
              --url https://api.openlayer.com/v1/projects/3fa85f64-5717-4562-b3fc-2c963f66afa6/tests \
              --header 'Authorization: Bearer <token>' \
              --header 'Content-Type: application/json' \
              --data '{
                "payloads": [
                  {
                    "id": "9a8b7c6d-5e4f-4a3b-2c1d-0e9f8a7b6c5d",
                    "name": "No PII in responses",
                    "archived": false
                  }
                ]
              }'
  '/versions/{projectVersionId}/results':
    get:
      tags:
        - Development
      summary: List commit test results
      operationId: listTestResultsByProjectVersion
      description: List the test results for a project commit (project version).
      parameters:
        - $ref: '#/components/parameters/projectVersionId'
        - $ref: '#/components/parameters/page'
        - $ref: '#/components/parameters/perPage'
        - $ref: '#/components/parameters/goalType'
        - $ref: '#/components/parameters/includeArchived'
        - $ref: '#/components/parameters/goalStatus'
      responses:
        '200':
          description: Status OK.
          headers:
            x-next:
              description: A link to the next page of responses
              schema:
                type: string
          content:
            application/json:
              schema:
                type: object
                required:
                  - items
                properties:
                  items:
                    type: array
                    items:
                      $ref: '#/components/schemas/GoalResult'
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            test_results = client.commits.test_results.list(
                "b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20",
                status="failing",
            )
            for test_result in test_results.items:
                print(test_result.id, test_result.status)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const testResults = await client.commits.testResults.list('b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20', {
              status: 'failing',
            });

            console.log(testResults.items);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\nresults, err := client.Commits.TestResults.List(\n\tcontext.TODO(),\n\t\"b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20\",\n\topenlayer.CommitTestResultListParams{\n\t\tStatus: openlayer.F(openlayer.CommitTestResultListParamsStatusFailing),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", results.Items)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.commits.testresults.TestResultListParams;
            import com.openlayer.api.models.commits.testresults.TestResultListResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            TestResultListParams params = TestResultListParams.builder()
                .projectVersionId("b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20")
                .status(TestResultListParams.Status.FAILING)
                .build();
            TestResultListResponse testResults = client.commits().testResults().list(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            test_results = openlayer.commits.test_results.list(
              "b4dd9ab3-0dd8-41cd-a56c-15b8fcc5ff20",
              status: :failing
            )

            puts(test_results)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/versions/{projectVersionId}/results \
              --header 'Authorization: Bearer <token>'
  '/inference-pipelines/{inferencePipelineId}':
    get:
      tags:
        - Monitoring
      summary: Retrieve an inference pipeline
      description: Retrieve an inference pipeline.
      parameters:
        - $ref: '#/components/parameters/inferencePipelineId'
        - name: expand
          in: query
          description: Expand specific nested objects.
          required: false
          schema:
            type: array
            items:
              type: string
              enum:
                - project
                - workspace
      responses:
        '200':
          description: Status OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InferencePipeline'
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            inference_pipeline = client.inference_pipelines.retrieve(
                "c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f",
                expand=["project"],
            )
            print(inference_pipeline.name, inference_pipeline.status)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const inferencePipeline = await client.inferencePipelines.retrieve('c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f', {
              expand: ['project'],
            });

            console.log(inferencePipeline.name);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\npipeline, err := client.InferencePipelines.Get(\n\tcontext.TODO(),\n\t\"c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f\",\n\topenlayer.InferencePipelineGetParams{\n\t\tExpand: openlayer.F([]openlayer.InferencePipelineGetParamsExpand{openlayer.InferencePipelineGetParamsExpandProject}),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", pipeline.Name)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.inferencepipelines.InferencePipelineRetrieveParams;
            import com.openlayer.api.models.inferencepipelines.InferencePipelineRetrieveResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            InferencePipelineRetrieveParams params = InferencePipelineRetrieveParams.builder()
                .inferencePipelineId("c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f")
                .addExpand(InferencePipelineRetrieveParams.Expand.PROJECT)
                .build();
            InferencePipelineRetrieveResponse inferencePipeline = client.inferencePipelines().retrieve(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            inference_pipeline = openlayer.inference_pipelines.retrieve(
              "c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f",
              expand: [:project]
            )

            puts(inference_pipeline)
        - lang: curl
          source: |
            curl --request GET \
              --url https://api.openlayer.com/v1/projects/{projectId}/inference-pipelines/{inferencePipelineId} \
              --header 'Authorization: Bearer <token>'
    put:
      tags:
        - Monitoring
      summary: Update an inference pipeline
      description: Update an inference pipeline.
      parameters:
        - $ref: '#/components/parameters/inferencePipelineId'
      responses:
        '200':
          description: Status OK.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InferencePipeline'
        default:
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  $ref: '#/components/schemas/InferencePipeline/properties/name'
                description:
                  $ref: '#/components/schemas/InferencePipeline/properties/description'
                referenceDatasetUri:
                  type: string
                  maxLength: 1000
                  nullable: true
                  writeOnly: true
                  description: The storage uri of your reference dataset. We recommend using the Python SDK or the UI to handle your reference dataset updates.
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            inference_pipeline = client.inference_pipelines.update(
                "c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f",
                name="production",
                description="Production traffic from the support chatbot.",
            )
            print(inference_pipeline.name)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const inferencePipeline = await client.inferencePipelines.update('c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f', {
              name: 'production',
              description: 'Production traffic for the support chatbot.',
            });

            console.log(inferencePipeline.name);
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\npipeline, err := client.InferencePipelines.Update(\n\tcontext.TODO(),\n\t\"c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f\",\n\topenlayer.InferencePipelineUpdateParams{\n\t\tName:        openlayer.F(\"production-v2\"),\n\t\tDescription: openlayer.F(\"Production traffic for the support chatbot.\"),\n\t},\n)\nif err != nil {\n\tpanic(err.Error())\n}\nfmt.Printf(\"%+v\\n\", pipeline.Name)\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;
            import com.openlayer.api.models.inferencepipelines.InferencePipelineUpdateParams;
            import com.openlayer.api.models.inferencepipelines.InferencePipelineUpdateResponse;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            InferencePipelineUpdateParams params = InferencePipelineUpdateParams.builder()
                .inferencePipelineId("c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f")
                .name("production")
                .description("This pipeline is used for production.")
                .build();
            InferencePipelineUpdateResponse inferencePipeline = client.inferencePipelines().update(params);
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            inference_pipeline = openlayer.inference_pipelines.update(
              "c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f",
              name: "production",
              description: "This pipeline is used for production."
            )

            puts(inference_pipeline)
        - lang: curl
          source: |
            curl --request PUT \
              --url https://api.openlayer.com/v1/projects/{projectId}/inference-pipelines/{inferencePipelineId} \
              --header 'Authorization: Bearer <token>' \
              --data '{"name": "New Name"}'
    delete:
      tags:
        - Monitoring
      summary: Delete an inference pipeline
      description: Delete an inference pipeline.
      parameters:
        - $ref: '#/components/parameters/inferencePipelineId'
      responses:
        '200':
          description: Response OK.
        default:
          $ref: '#/components/responses/UnexpectedError'
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            client.inference_pipelines.delete("c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f")
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            await client.inferencePipelines.delete('c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f');
        - lang: go
          source: "package main\n\nimport (\n\t\"context\"\n\n\t\"github.com/openlayer-ai/openlayer-go\"\n)\n\nclient := openlayer.NewClient()\nerr := client.InferencePipelines.Delete(context.TODO(), \"c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f\")\nif err != nil {\n\tpanic(err.Error())\n}\n"
        - lang: java
          source: |
            import com.openlayer.api.client.OpenlayerClient;
            import com.openlayer.api.client.okhttp.OpenlayerOkHttpClient;

            OpenlayerClient client = OpenlayerOkHttpClient.fromEnv();

            client.inferencePipelines().delete("c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f");
        - lang: ruby
          source: |
            require "openlayer"

            openlayer = Openlayer::Client.new(api_key: ENV["OPENLAYER_API_KEY"])

            openlayer.inference_pipelines.delete("c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f")
        - lang: curl
          source: |
            curl --request DELETE \
              --url https://api.openlayer.com/v1/projects/{projectId}/inference-pipelines/{inferencePipelineId} \
              --header 'Authorization: Bearer <token>'
  '/inference-pipelines/{inferencePipelineId}/data-stream':
    post:
      tags:
        - Monitoring
      summary: Publish inference
      operationId: streamData
      description: Publish an inference data point to an inference pipeline.
      parameters:
        - $ref: '#/components/parameters/inferencePipelineId'
      responses:
        '200':
          description: Status OK.
          content:
            application/json:
              schema:
                type: object
                required:
                  - success
                properties:
                  success:
                    type: boolean
                    enum:
                      - true
        '500':
          $ref: '#/components/responses/UnexpectedError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                rows:
                  type: array
                  description: A list of inference data points with inputs and outputs
                  example:
                    - user_query: what is the meaning of life?
                      output: '42'
                      tokens: 7
                      cost: 0.02
                      timestamp: 1620000000
                  nullable: false
                  items:
                    type: object
                    additionalProperties: true
                config:
                  oneOf:
                    - $ref: '#/components/schemas/LLMData'
                    - $ref: '#/components/schemas/TabularClassificationData'
                    - $ref: '#/components/schemas/TabularRegressionData'
                    - $ref: '#/components/schemas/TextClassificationData'
                  example:
                    prompt:
                      - role: user
                        content: '{{ user_query }}'
                    inputVariableNames:
                      - user_query
                    outputColumnName: output
                    timestampColumnName: timestamp
                    costColumnName: cost
                    numOfTokenColumnName: tokens
                  description: Configuration for the data stream. Depends on your **Openlayer project task type**.
              required:
                - rows
                - config
      x-codeSamples:
        - lang: python
          source: |
            from openlayer import Openlayer

            client = Openlayer()

            response = client.inference_pipelines.data.stream(
                "c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f",
                config={
                    "input_variable_names": ["user_query"],
                    "output_column_name": "output",
                    "num_of_token_column_name": "tokens",
                    "cost_column_name": "cost",
                    "timestamp_column_name": "timestamp",
                },
                rows=[
                    {
                        "user_query": "What is the meaning of life?",
                        "output": "42",
                        "tokens": 7,
                        "cost": 0.02,
                        "timestamp": 1620000000,
                    }
                ],
            )
            print(response.success)
        - lang: typescript
          source: |
            import Openlayer from 'openlayer';

            const client = new Openlayer();

            const response = await client.inferencePipelines.data.stream('c1d2e3f4-a5b6-4c7d-8e9f-0a1b2c3d4e5f', {
              config: {
                inputVariableNames: ['user_query'],
                outputColumnName: 'output',
                numOfTokenColumnName: 'tokens',
                costColumnName: 'cost',
                timestampColumnName: 'timestamp',
              },
              rows: [
                {
                  user_query: 'What is the meaning of life?',
                  output: '42',
                  tokens: 7,
                  cost: 0.02,
                  timestamp: 1610000000,
                },
              ],
            });

            console.log(response.success);
        - lang: go
[...]
